Index: build/jam/OptionalPackageDependencies
===================================================================
--- build/jam/OptionalPackageDependencies	(revision 30863)
+++ build/jam/OptionalPackageDependencies	(working copy)
@@ -3,6 +3,7 @@
 # For transitive dependencies dependants should be listed before their
 # dependencies.
 
+OptionalPackageDependencies Subversion : OpenSSL APR-util Neon LibIconv SQLite ;
 OptionalPackageDependencies APR-util : APR ;
 OptionalPackageDependencies BeHappy : BeBook NetSurf ;
 OptionalPackageDependencies Development : DevelopmentBase Perl ;
@@ -10,4 +11,4 @@
 OptionalPackageDependencies LibLayout : DevelopmentBase ;
 OptionalPackageDependencies NetSurf : OpenSSL ;
 OptionalPackageDependencies OpenSSH : OpenSSL ;
-OptionalPackageDependencies Subversion : OpenSSL ;
+
Index: build/jam/OptionalPackages
===================================================================
--- build/jam/OptionalPackages	(revision 30863)
+++ build/jam/OptionalPackages	(working copy)
@@ -26,8 +26,10 @@
 #	DevelopmentMin		- development headers, libs, tools, from sources only
 #	Firefox
 #	KeymapSwitcher
+#	LibIconv
 #	LibLayout
 #	Links
+#	Neon
 #	NetSurf
 #	OpenSound
 #	OpenSSH
@@ -35,7 +37,9 @@
 #	P7zip
 #	Pe
 #	Perl
+#	Python
 #	Rsync
+#	SQLite
 #	Subversion
 #	Tar
 #	UserlandFS
@@ -51,9 +55,9 @@
 	if $(TARGET_ARCH) != x86 {
 		Echo "No optional package APR available for $(TARGET_ARCH)" ;
 	} else {
-		local baseURL = http://haiku-files.org/files/optional-packages ;
-		InstallOptionalHaikuImagePackage apr-0.9.17-gcc2-2008-05-20
-			: $(baseURL)/apr-0.9.17-gcc2-2008-05-20.zip
+		local baseURL = http://www.haiku-ports.de/packages/dev-libs/apr ;
+		InstallOptionalHaikuImagePackage apr-1.3.3-gcc2-haiku-2009-05-08
+			: $(baseURL)/apr-1.3.3-gcc2-haiku-2009-05-08.zip
 			:
 		;
 	}
@@ -65,9 +69,9 @@
 	if $(TARGET_ARCH) != x86 {
 		Echo "No optional package APR-util available for $(TARGET_ARCH)" ;
 	} else {
-		local baseURL = http://haiku-files.org/files/optional-packages ;
-		InstallOptionalHaikuImagePackage apr-util-0.9.15-gcc2-2008-05-15
-			: $(baseURL)/apr-util-0.9.15-gcc2-2008-05-15.zip
+		local baseURL = http://www.haiku-ports.de/packages/dev-libs/apr-util ;
+		InstallOptionalHaikuImagePackage apr-util-1.3.4-gcc2-haiku-2009-05-08
+			: $(baseURL)/apr-util-1.3.4-gcc2-haiku-2009-05-08.zip
 			:
 		;
 	}
@@ -310,8 +314,9 @@
 	if $(TARGET_ARCH) != x86 {
 		Echo "No optional package Firefox available for $(TARGET_ARCH)" ;
 	} else if $(HAIKU_GCC_VERSION[1]) >= 4 && $(isHybridBuild) = 0 {
+		local baseURL = http://haiku-files.org/files/optional-packages ;
 		InstallOptionalHaikuImagePackage BeZillaBrowser-2.0.0.21pre-haiku-gcc4-x86-09-03-01
-			: http://haiku-files.org/files/optional-packages/BeZillaBrowser-2.0.0.21pre-haiku-gcc4-x86-09-03-01.zip
+			: $(baseURL)/BeZillaBrowser-2.0.0.21pre-haiku-gcc4-x86-09-03-01.zip
  			: apps
  		;
  		AddSymlinkToHaikuImage home config be Applications
@@ -347,6 +352,22 @@
 }
 
 
+# LibIconv
+if [ IsOptionalHaikuImagePackageAdded LibIconv ] {
+	if $(TARGET_ARCH) != x86 {
+		Echo "No optional package LibIconv available for $(TARGET_ARCH)" ;
+	} else if $(HAIKU_GCC_VERSION[1]) >= 4 {
+		Echo "No optional package LibIconv available for gcc4" ;
+	} else {
+		local baseURL = http://www.haiku-ports.de/packages/dev-libs/libiconv ;
+		InstallOptionalHaikuImagePackage libiconv-1.13-gcc2-haiku-2009-05-22
+			: $(baseURL)/libiconv-1.13-gcc2-haiku-2009-05-22.zip
+			:
+		;
+	}
+}
+
+
 # LibLayout library
 if [ IsOptionalHaikuImagePackageAdded LibLayout ] {
 	if $(TARGET_ARCH) != x86 {
@@ -380,6 +401,20 @@
 }
 
 
+# Neon
+if [ IsOptionalHaikuImagePackageAdded Neon ] {
+	if $(TARGET_ARCH) != x86 {
+		Echo "No optional package Neon available for $(TARGET_ARCH)" ;
+	} else {
+		local baseURL = http://www.haiku-ports.de/packages/net-misc/neon ;
+		InstallOptionalHaikuImagePackage neon-0.28.4-gcc2-haiku-2009-05-23
+			: $(baseURL)/neon-0.28.4-gcc2-haiku-2009-05-23.zip
+			:
+		;
+	}
+}
+
+
 # NetSurf web browser
 if [ IsOptionalHaikuImagePackageAdded NetSurf ] {
 	if $(TARGET_ARCH) != x86 {
@@ -421,9 +456,9 @@
 				"variable to be set!" ;
 		}
 
-		local baseURL = http://haiku-files.org/files/optional-packages ;
-		InstallOptionalHaikuImagePackage openssh-5.0p1-gcc2-2008-05-04-1
-			: $(baseURL)/openssh-5.0p1-gcc2-2008-05-04-1.zip
+		local baseURL = http://www.haiku-ports.de/packages/net-misc/openssh ;
+		InstallOptionalHaikuImagePackage openssh-5.2p1-gcc2-haiku-2009-05-27
+			: $(baseURL)/openssh-5.2p1-gcc2-haiku-2009-05-27.zip
 			:
 		;
 
@@ -453,8 +488,9 @@
 	} else if $(HAIKU_GCC_VERSION[1]) >= 4 && $(isHybridBuild) = 0 {
 		Echo "No optional package P7zip available for gcc4" ;
 	} else {
-		InstallOptionalHaikuImagePackage p7zip-4.65-gcc2-haiku-2009-05-20
-			: http://haiku-files.org/files/optional-packages/p7zip-4.65-gcc2-haiku-2009-05-20.zip
+		local baseURL = http://www.haiku-ports.de/packages/app-arch/p7zip ;
+		InstallOptionalHaikuImagePackage p7zip-4.65-gcc2-haiku-2009-05-24
+			: $(baseURL)/p7zip-4.65-gcc2-haiku-2009-05-24.zip
 			:
 		;
 
@@ -511,6 +547,36 @@
 }
 
 
+# Python
+if [ IsOptionalHaikuImagePackageAdded Python ] {
+	if $(TARGET_ARCH) != x86 {
+		Echo "No optional package Python available for $(TARGET_ARCH)" ;
+	} else {
+		local baseURL = http://www.haiku-ports.de/packages/dev-lang/python ;
+		InstallOptionalHaikuImagePackage python-2.6.2-gcc2-haiku-2009-05-14
+			: $(baseURL)/python-2.6.2-gcc2-haiku-2009-05-14.zip
+			:
+		;
+	}
+}
+
+
+# SQLite
+if [ IsOptionalHaikuImagePackageAdded SQLite ] {
+	if $(TARGET_ARCH) != x86 {
+		Echo "No optional package SQLite available for $(TARGET_ARCH)" ;
+	} else if $(HAIKU_GCC_VERSION[1]) >= 4 {
+		Echo "No optional package SQLite available for gcc4" ;
+	} else {
+		local baseURL = http://www.haiku-ports.de/packages/dev-db/sqlite ;
+		InstallOptionalHaikuImagePackage sqlite-3.6.14-gcc2-haiku-2009-05-10
+			: $(baseURL)/sqlite-3.6.14-gcc2-haiku-2009-05-10.zip
+			:
+		;
+	}
+}
+
+
 # Rsync
 if [ IsOptionalHaikuImagePackageAdded Rsync ] {
 	if $(TARGET_ARCH) != x86 {
@@ -530,9 +596,10 @@
 	if $(TARGET_ARCH) != x86 {
 		Echo "No optional package Subversion available for $(TARGET_ARCH)" ;
 	} else {
-		InstallOptionalHaikuImagePackage Subversion
-			: http://haiku.mlotz.ch/subversion-1.4.6-haiku-20080628.zip
-			: home
+		local baseURL = http://www.haiku-ports.de/packages/dev-util/subversion ;
+		InstallOptionalHaikuImagePackage subversion-1.6.2-gcc2-haiku-2009-05-20
+			: $(baseURL)/subversion-1.6.2-gcc2-haiku-2009-05-20.zip
+			:
 		;
 	}
 }