Index: src/kits/tracker/SettingsViews.cpp
===================================================================
--- src/kits/tracker/SettingsViews.cpp	(revision 29775)
+++ src/kits/tracker/SettingsViews.cpp	(working copy)
@@ -1443,3 +1443,115 @@
 		|| fAskBeforeDeleteFile != (fAskBeforeDeleteFileCheckBox->Value() > 0);
 }
 
+
+// #pragma mark -
+
+
+ReplicantsSettingsView::ReplicantsSettingsView(BRect rect)
+	: SettingsView(rect, "ReplicantsSettingsView")
+{
+	rect.OffsetTo(B_ORIGIN);
+	fShowReplicantDraggersCheckBox = new BCheckBox(rect, "", 
+		"Show Replicant Draggers", 
+		new BMessage(kShowReplicantDraggers));
+	fShowReplicantDraggersCheckBox->ResizeToPreferred();
+	AddChild(fShowReplicantDraggersCheckBox);
+}
+
+
+void
+ReplicantsSettingsView::GetPreferredSize(float *_width, float *_height)
+{
+	if (_width != NULL) {
+		float width = fShowReplicantDraggersCheckBox->Bounds().Width();
+
+		*_width = width;
+	}
+
+	if (_height != NULL)
+		*_height = fShowReplicantDraggersCheckBox->Frame().bottom;
+}
+
+
+void
+ReplicantsSettingsView::AttachedToWindow()
+{
+	fShowReplicantDraggersCheckBox->SetTarget(this);
+	ShowCurrentSettings();
+}
+
+
+void
+ReplicantsSettingsView::MessageReceived(BMessage *message)
+{
+	TTracker *tracker = dynamic_cast<TTracker *>(be_app);
+	if (!tracker)
+		return;
+	TrackerSettings settings;
+		
+	switch (message->what) {
+		case kShowReplicantDraggers:
+			if (fShowReplicantDraggersCheckBox->Value()
+				== B_CONTROL_ON) {
+				BDragger::ShowAllDraggers();
+			} else {
+				BDragger::HideAllDraggers();
+			}
+			Window()->PostMessage(kSettingsContentsModified);
+			break;
+
+		default:
+			_inherited::MessageReceived(message);
+			break;
+	}
+}
+
+	
+void
+ReplicantsSettingsView::SetDefaults()
+{
+	ShowCurrentSettings();
+}
+
+
+bool
+ReplicantsSettingsView::IsDefaultable() const
+{
+	return false;
+}
+
+
+void
+ReplicantsSettingsView::Revert()
+{
+
+}
+
+
+void
+ReplicantsSettingsView::_SendNotices()
+{
+	
+}
+
+
+void
+ReplicantsSettingsView::ShowCurrentSettings()
+{
+	fShowReplicantDraggersCheckBox->SetValue(BDragger::AreDraggersDrawn());
+}
+
+
+void
+ReplicantsSettingsView::RecordRevertSettings()
+{
+	
+}
+
+
+bool
+ReplicantsSettingsView::IsRevertable() const
+{
+	return false;
+}
+
Index: src/kits/tracker/TrackerSettingsWindow.cpp
===================================================================
--- src/kits/tracker/TrackerSettingsWindow.cpp	(revision 29775)
+++ src/kits/tracker/TrackerSettingsWindow.cpp	(working copy)
@@ -119,6 +119,8 @@
 		new TrashSettingsView(rect)));
 	fSettingsTypeListView->AddItem(new SettingsItem("Volume Icons",
 		new SpaceBarSettingsView(rect)));
+	fSettingsTypeListView->AddItem(new SettingsItem("Replicants",
+		new ReplicantsSettingsView(rect)));
 
 	// compute preferred view size
 
Index: src/kits/tracker/SettingsViews.h
===================================================================
--- src/kits/tracker/SettingsViews.h	(revision 29775)
+++ src/kits/tracker/SettingsViews.h	(working copy)
@@ -229,6 +229,29 @@
 		typedef SettingsView _inherited;
 };
 
+class ReplicantsSettingsView : public SettingsView {
+	public:
+		ReplicantsSettingsView(BRect frame);
+
+		virtual void MessageReceived(BMessage *message);
+		virtual void AttachedToWindow();
+		virtual void GetPreferredSize(float *_width, float *_height);
+
+		virtual void SetDefaults();
+		virtual bool IsDefaultable() const;
+		virtual void Revert();
+		virtual void ShowCurrentSettings();
+		virtual void RecordRevertSettings();
+		virtual bool IsRevertable() const;
+
+	private:
+		void _SendNotices();
+
+		BCheckBox *fShowReplicantDraggersCheckBox;
+
+		typedef SettingsView _inherited;
+};
+
 } // namespace BPrivate
 
 using namespace BPrivate;
Index: src/kits/tracker/Commands.h
===================================================================
--- src/kits/tracker/Commands.h	(revision 29775)
+++ src/kits/tracker/Commands.h	(working copy)
@@ -136,6 +136,8 @@
 const uint32 kDontMoveFilesToTrashChanged = 'STdm';
 const uint32 kAskBeforeDeleteFileChanged = 'STad';
 
+const uint32 kShowReplicantDraggers = 'TDra';
+
 } // namespace BPrivate
 
 using namespace BPrivate;