Index: src/data/beos_mime/audio/ogg
===================================================================
--- src/data/beos_mime/audio/ogg	(revision 0)
+++ src/data/beos_mime/audio/ogg	(revision 0)
@@ -0,0 +1,17 @@
+
+resource(0, "BEOS:TYPE") #'MIMS' "application/x-vnd.Be-meta-mime";
+
+resource(1, "META:TYPE") "audio/ogg";
+
+resource(2, "META:SNIFF_RULE") "0.50 (\"OggS\")";
+
+resource(3, "META:S:DESC") #'MSDC' "OGG Sound File";
+
+resource(4, "META:EXTENS") message(234) {
+	"extensions" = "ogg",
+	"extensions" = "oga",
+	"extensions" = "spx",
+	"type" = "audio/ogg"
+};
+
+resource(5, "META:PREF_APP") #'MSIG' "application/x-vnd.Haiku.MediaPlayer";
Index: src/data/beos_mime/application/ogg
===================================================================
--- src/data/beos_mime/application/ogg	(revision 29844)
+++ src/data/beos_mime/application/ogg	(arbetskopia)
@@ -5,11 +5,10 @@
 
 resource(2, "META:SNIFF_RULE") "0.50 (\"OggS\")";
 
-resource(3, "META:S:DESC") #'MSDC' "OGG Movie";
+resource(3, "META:S:DESC") #'MSDC' "OGG Multimedia File";
 
 resource(4, "META:EXTENS") message(234) {
-	"extensions" = "ogg",
-	"extensions" = "ogm",
+	"extensions" = "ogx",
 	"type" = "application/ogg"
 };
 
Index: src/data/beos_mime/text/css
===================================================================
--- src/data/beos_mime/text/css	(revision 0)
+++ src/data/beos_mime/text/css	(revision 0)
@@ -0,0 +1,13 @@
+
+resource(0, "BEOS:TYPE") #'MIMS' "application/x-vnd.Be-meta-mime";
+
+resource(1, "META:TYPE") "text/css";
+
+resource(2, "META:S:DESC") #'MSDC' "Cascading Style Sheet";
+
+resource(3, "META:EXTENS") message(234) {
+	"extensions" = "css",
+	"type" = "text/css"
+};
+
+resource(4, "META:PREF_APP") #'MSIG' "application/x-vnd.Haiku-StyledEdit";
Index: src/data/beos_mime/text/csv
===================================================================
--- src/data/beos_mime/text/csv	(revision 0)
+++ src/data/beos_mime/text/csv	(revision 0)
@@ -0,0 +1,13 @@
+
+resource(0, "BEOS:TYPE") #'MIMS' "application/x-vnd.Be-meta-mime";
+
+resource(1, "META:TYPE") "text/csv";
+
+resource(2, "META:S:DESC") #'MSDC' "Comma-Separated Values";
+
+resource(3, "META:EXTENS") message(234) {
+	"extensions" = "csv",
+	"type" = "text/csv"
+};
+
+resource(4, "META:PREF_APP") #'MSIG' "application/x-vnd.Haiku-StyledEdit";
Index: src/data/beos_mime/video/3gpp
===================================================================
--- src/data/beos_mime/video/3gpp	(revision 0)
+++ src/data/beos_mime/video/3gpp	(revision 0)
@@ -0,0 +1,14 @@
+
+resource(0, "BEOS:TYPE") #'MIMS' "application/x-vnd.Be-meta-mime";
+
+resource(1, "META:TYPE") "video/3gpp";
+
+resource(2, "META:S:DESC") #'MSDC' "3GPP Multimedia File";
+
+resource(3, "META:EXTENS") message(234) {
+	"extensions" = "3gp",
+	"extensions" = "3gpp",
+	"type" = "video/3gpp"
+};
+
+resource(4, "META:PREF_APP") #'MSIG' "application/x-vnd.Haiku-MediaPlayer";
Index: src/data/beos_mime/video/3gpp2
===================================================================
--- src/data/beos_mime/video/3gpp2	(revision 0)
+++ src/data/beos_mime/video/3gpp2	(revision 0)
@@ -0,0 +1,14 @@
+
+resource(0, "BEOS:TYPE") #'MIMS' "application/x-vnd.Be-meta-mime";
+
+resource(1, "META:TYPE") "video/3gpp2";
+
+resource(2, "META:S:DESC") #'MSDC' "3GPP2 Multimedia File";
+
+resource(3, "META:EXTENS") message(234) {
+	"extensions" = "3g2",
+	"extensions" = "3gpp2",
+	"type" = "video/3gpp2"
+};
+
+resource(4, "META:PREF_APP") #'MSIG' "application/x-vnd.Haiku-MediaPlayer";
Index: src/data/beos_mime/video/ogg
===================================================================
--- src/data/beos_mime/video/ogg	(revision 0)
+++ src/data/beos_mime/video/ogg	(revision 0)
@@ -0,0 +1,16 @@
+
+resource(0, "BEOS:TYPE") #'MIMS' "application/x-vnd.Be-meta-mime";
+
+resource(1, "META:TYPE") "video/ogg";
+
+resource(2, "META:SNIFF_RULE") "0.50 (\"OggS\")";
+
+resource(3, "META:S:DESC") #'MSDC' "OGG Movie";
+
+resource(4, "META:EXTENS") message(234) {
+	"extensions" = "ogv",
+	"extensions" = "ogm",
+	"type" = "video/ogg"
+};
+
+resource(5, "META:PREF_APP") #'MSIG' "application/x-vnd.Haiku.MediaPlayer";